import { PluginInterface, OrderType } from '@debut/types';
import { TrailingType } from '@debut/plugin-virtual-takes';
type GridLevel = {
    price: number;
    activated: boolean;
};
interface Methods {
    createGrid(price: number, type?: OrderType): Grid;
    disposeGrid(): void;
    getGrid(): Grid | null;
}
export interface GridPluginInterface extends PluginInterface {
    name: 'grid';
    api: Methods;
}
export interface GridPluginAPI {
    grid: Methods;
}
export type GridPluginOptions = {
    step: number;
    fibo?: number;
    martingale: number;
    levelsCount: number;
    takeProfit: number;
    stopLoss?: number;
    reduceEquity?: boolean;
    trailing?: TrailingType;
    trailingDistance?: number;
    trailingAndReduce?: boolean;
    collapse?: boolean;
    timePause?: number;
    trend?: boolean;
    reduceTakeOnTime?: number;
};
export declare function gridPlugin(opts: GridPluginOptions): GridPluginInterface;
export interface Grid {
    nextUpIdx: number;
    nextLowIdx: number;
    upLevels: GridLevel[];
    lowLevels: GridLevel[];
}
export {};
